package Database

func GetPostById(id string) (Post, error) {
	var (
		post Post
		e    error
	)

	e = DB.Model(&Post{}).
		Where("id = ?", id).
		First(&post).
		Error

	return post, e
}

func GetPostsList(limit int, offset int) ([]Post, error) {
	var (
		posts []Post
		e     error
	)

	e = DB.Model(&Post{}).
		Order("created_at desc").
		Limit(limit).
		Offset(offset).
		Find(&posts).
		Error

	return posts, e
}

func CreatePost(post Post) error {
	return DB.Model(&Post{}).
		Create(&post).
		Error
}

func UpdatePost(post Post) error {
	return DB.Save(&post).Error
}
